//------------------------------------------------------------------------------
// IPS JS: Form Functions
// (c) 2005 Invision Power Services, Inc.
// http://www.invisionpower.com
// Matt Mecham (17/10/05)
//------------------------------------------------------------------------------

var _form_functions = null;

/*-------------------------------------------------------------------------*/
// Initiate object
/*-------------------------------------------------------------------------*/

function form_functions()
{
	/**
	* Name: Form
	*
	* @var string
	*/
	this.name_form      = 'mainform';
	
	/**
	* ID: Form
	*
	* @var string
	*/
	this.obj_form        = null;
	
	/**
	* ID: Form Edited
	*
	* @var INT
	*/
	this.form_edited    = 1;
	
	/**
	* NAME: Edit hold
	*
	* @var string
	*/
	this.name_edit_hold = 'page-edit-hold';
	
	/**
	* ID: Edit hold
	*
	* @var string
	*/
	this.id_edit_hold   = null;
	
	/**
	* Saved onsubmit handlers
	*
	* @var string
	*/
	this.form_onsubmit_saved = null;
	
	/**
	* Array of form BUTTON div id names
	*
	* @var array
	*/
	this.form_button_divs = new Array();
	
	/**
	* Array of form LINK div id names
	*
	* @var array
	*/
	this.form_link_divs = new Array();
	
	/**
	* Array of form EVAL div id names
	*
	* @var array
	*/
	this.form_eval_divs = new Array();
	
	/**
	* CSS styles: Button off
	*
	* @var string
	*/
	this.css_formbutton_off = 'formbutton-off';
	
	/**
	* CSS styles: Button on
	*
	* @var string
	*/
	this.css_formbutton_on  = 'formbutton-on';
}

/*-------------------------------------------------------------------------*/
// Initiate object 
/*-------------------------------------------------------------------------*/

form_functions.prototype.init = function()
{
	//----------------------------------
	// Get form object
	//----------------------------------
	
	this.obj_form = document.getElementById( this.name_form );
	
	//----------------------------------
	// Already got a submit handler?
	//----------------------------------
	
	if ( this.obj_form.onsubmit )
	{
		this.form_onsubmit_saved = this.obj_form.onsubmit;
	}
	
	//----------------------------------
	// Got the hold box?
	//----------------------------------
	
	try
	{
		this.id_edit_hold = document.getElementById( this.name_edit_hold );
	}
	catch(error)
	{

	}
	
	//----------------------------------
	// Get page links...
	// Gah.. another safari bug
	//----------------------------------
	
	var inputs = this.obj_form.getElementsByTagName('INPUT');
	
	_form_functions = this;
	
	//----------------------------------
	// Sort through and grab links
	//----------------------------------
	
	for ( var i = 0 ; i <= inputs.length ; i++ )
	{
		try
		{
			if ( inputs[i].type == 'hidden' )
			{
				continue;
			}
		}
		catch(error)
		{
			continue;
		}
		
		inputs[i].onchange = this.form_event_edited;
	}
	
	//----------------------------------
	// Form check...
	//----------------------------------
	
	this.obj_form.onsubmit = this.form_submit;
};

/*-------------------------------------------------------------------------*/
// Initiate object 
/*-------------------------------------------------------------------------*/

form_functions.prototype.add_submit_event = function( div_id, field_name, init_value, onsubmit_value )
{
	var div_obj = null;
	
	//----------------------------------
	// Make sure we got one...
	//----------------------------------
	
	try
	{
		div_obj = document.getElementById( div_id );
	}
	catch( error )
	{
		alert( "Could not initialize field: " + div_id );
		return false;
	}
	
	//----------------------------------
	// Add hidden field to form...
	//----------------------------------
	
	if ( field_name )
	{
		var field   = document.createElement('input');
		
		field.type  = 'hidden';
		field.value = init_value;
		field.name  = field_name;
		field.id    = 'field--x--' + div_id;
		
		this.obj_form.appendChild( field );
		
		this.form_button_divs[ div_id ] = onsubmit_value;
	}
	
	//----------------------------------
	// Add event handlers...
	//----------------------------------
	
	div_obj.onmouseover = this.form_button_mouseover;
	div_obj.onmouseout  = this.form_button_mouseout;
	div_obj.onclick     = this.form_button_submit;
	
	div_obj.className   = this.css_formbutton_off;
};

/*-------------------------------------------------------------------------*/
// Add EVAL event 
/*-------------------------------------------------------------------------*/

form_functions.prototype.add_eval_event = function( div_id, eval_code )
{
	var div_obj = null;
	
	//----------------------------------
	// Make sure we got one...
	//----------------------------------
	
	try
	{
		div_obj = document.getElementById( div_id );
	}
	catch( error )
	{
		alert( "Could not initialize event: " + div_id );
		return false;
	}
	
	this.form_eval_divs[ div_id ] = eval_code;
	
	//----------------------------------
	// Add event handlers...
	//----------------------------------
	
	div_obj.onmouseover = this.form_button_mouseover;
	div_obj.onmouseout  = this.form_button_mouseout;
	div_obj.onclick     = this.form_button_eval_click;
	
	div_obj.className   = this.css_formbutton_off;
};

/*-------------------------------------------------------------------------*/
// Add LINK event 
/*-------------------------------------------------------------------------*/

form_functions.prototype.add_link_event = function( div_id, link_url )
{
	var div_obj = null;
	
	//----------------------------------
	// Make sure we got one...
	//----------------------------------
	
	try
	{
		div_obj = document.getElementById( div_id );
	}
	catch( error )
	{
		alert( "Could not initialize event: " + div_id );
		return false;
	}
	
	this.form_link_divs[ div_id ] = link_url;
	
	//----------------------------------
	// Add event handlers...
	//----------------------------------
	
	div_obj.onmouseover = this.form_button_mouseover;
	div_obj.onmouseout  = this.form_button_mouseout;
	div_obj.onclick     = this.form_button_link_click;
	
	div_obj.className   = this.css_formbutton_off;
};

/*-------------------------------------------------------------------------*/
// Div EVAL has been clicked...
/*-------------------------------------------------------------------------*/

form_functions.prototype.form_button_eval_click = function()
{
	try
	{
		eval( _form_functions.form_eval_divs[ this.id ] );
	}
	catch( error )
	{
	
	}
};


/*-------------------------------------------------------------------------*/
// Div Link has been clicked...
/*-------------------------------------------------------------------------*/

form_functions.prototype.form_button_link_click = function()
{
	try
	{
		window.location = _form_functions.form_link_divs[ this.id ];
	}
	catch( error )
	{
	
	}
};

/*-------------------------------------------------------------------------*/
// The form has changed...
/*-------------------------------------------------------------------------*/

form_functions.prototype.form_button_submit = function()
{
	try
	{
		var field_obj   = document.getElementById( 'field--x--' + this.id );
		field_obj.value = _form_functions.form_button_divs[ this.id ];
	}
	catch( error )
	{
	
	}
	
	//----------------------------------
	// Submit..
	//----------------------------------
	
	_form_functions.form_submit();
	_form_functions.obj_form.submit();
};

/*-------------------------------------------------------------------------*/
// The form has changed...
/*-------------------------------------------------------------------------*/

form_functions.prototype.form_button_mouseover = function()
{
	this.className = _form_functions.css_formbutton_on;
};

/*-------------------------------------------------------------------------*/
// The form has changed...
/*-------------------------------------------------------------------------*/

form_functions.prototype.form_button_mouseout = function()
{
	this.className = _form_functions.css_formbutton_off;
};

/*-------------------------------------------------------------------------*/
// The form has changed...
/*-------------------------------------------------------------------------*/

form_functions.prototype.form_event_edited = function()
{
	_form_functions.form_edited = 1;
};

/*-------------------------------------------------------------------------*/
// The form has changed...
/*-------------------------------------------------------------------------*/

form_functions.prototype.form_submit = function()
{
	var retval = true;
	
	if ( _form_functions.form_edited )
	{
		//alert ("Form edited" );
	}
	
	if ( _form_functions.form_onsubmit_saved )
	{
		eval( 'tmpsubmit = ' + _form_functions.form_onsubmit_saved );
		retval = tmpsubmit();
	}
	
	return retval;
};

/*-------------------------------------------------------------------------*/
// The form has changed...
/*-------------------------------------------------------------------------*/

form_functions.prototype.document_onblur = function()
{
	if ( _form_functions.form_edited )
	{
		//alert ("Form edited" );
	}
};
